/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                                          *
*        C O M M O N   E U R O G A M    C O D E				   *
*                                                                          *
*        File:         vxBind.h						   *
*                                                                          *
*        Author:       Jomar Honsi          Date: 26/09/90                 *
*                                                                          *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef INCvxbind
#define INCvxbind

#include <stdioLib.h>
#include <fioLib.h>
#include <ioLib.h>

#ifdef VX_INCL_sym
#include <sysSymTbl.h>
#endif

#ifdef VX_INCL_ring
#include <rngLib.h>
#endif

#ifdef VX_INCL_host
#include <hostLib.h>
#endif

#ifdef VX_INCL_sema
#include <semSmLib.h>
#include <semLib.h>
#endif

#define __PROTOTYPE_5_0

#include <taskLib.h>

#ifdef VX_INCL_scsi
#include <scsiLib.h>
#endif

#ifdef VX_INCL_dosfs
#include <dosFsLib.h>
#endif

#ifdef VX_INCL_signal
#include <sigLib.h>
#endif

#ifdef VX_INCL_reboot
#include <rebootLib.h>
#endif

#ifdef VX_INCL_boot
#include <bootLib.h>
#endif

#ifdef VX_INCL_rem
#include <remLib.h>
#endif

#ifdef VX_INCL_mem
#include <memLib.h>
#endif


#ifdef VX_INCL_usr
#include <usrLib.h>
#endif

#ifdef VX_INCL_load
#include <loadLib.h>
#endif

#ifdef VX_INCL_errno
#include <errnoLib.h>
#endif

#ifdef VX_INCL_shell
#include <shellLib.h>
#endif

#ifdef VX_INCL_tick
#include <tickLib.h>
#endif

#ifdef VX_INCL_watchdog
#include <wdLib.h>
#endif

#ifdef VX_INCL_int
#include <intLib.h>
#endif



extern int sysClkRateGet();

/* output macros */

#define outstr(s)	(printf((s)))
#define outchar(c)	(printf("%c",(c)))
#define echo(c)		(printf("%c",(c)))

/*   VxWorks kernel interface */

#define psleep(t)	( taskDelay((t)) )
#define sdelay(s)	( taskDelay((s)*sysClkRateGet()) )
#define RSHD		514

extern int second;

#define N_TIMER		50

typedef struct {
    char *serverHost,	/* File server (from bootline) */
	*objPath,	/* Path of eurogam object code */
	*rshellHost,	/* For execution of remote shells */
	*rloginHost;	/* Host for remote login */
} SiteInfo;

enum {PORT1=0, PORT2, PORT3, PORT4, NTTYS };

#define B_PORT1 	(Byte)( 1<<PORT1 )
#define B_PORT2		(Byte)( 1<<PORT2 )
#define B_PORT3		(Byte)( 1<<PORT3 )
#define B_PORT4		(Byte)( 1<<PORT4 )
#define B_PORT_CONSOLE	(Byte)( B_PORT1 )
#define B_PORT_ALL	(Byte)( B_PORT1 + B_PORT2 + B_PORT3 + B_PORT4 )
#define B_PORT_NONE	(Byte)( 0 )

#endif
