#------------------------------------------------------------------------CM
set CM(frame-name) CM
set CM(frame-title) "Setting 2d Colours"
set CM(icon-title) optCM

set CMcell 0

set MAXCOLOURS 32

set CM(topographic2) [list \
   #000000 #000040 #000080 #0000c0 #0000ff #0040ff #0080ff #00c0ff \
   #00ffff #40ffff #80ffff #c0ffff #80ff80 #40ff40 #00ff00 #00c000 \
   #008000 #004000 #404000 #808000 #c0c000 #c0c040 #c0c080 #c0c0c0 \
   #ffffff #ffc0ff #ff80ff #ff40ff #ff00ff #ff0080 #ff0040 #ff0000 \
]

set CM(topographic2White) [list \
   #ffffff #000040 #000080 #0000c0 #0000ff #0040ff #0080ff #00c0ff \
   #00ffff #40ffff #80ffff #c0ffff #80ff80 #40ff40 #00ff00 #00c000 \
   #008000 #004000 #404000 #808000 #c0c000 #c0c040 #c0c080 #c0c0c0 \
   #ffffff #ffc0ff #ff80ff #ff40ff #ff00ff #ff0080 #ff0040 #ff0000 \
]

set CM(hue) [list \
   #606060 #0000ff #002aff #0055ff #007fff #00aaff #00d4ff #00ffff \
   #00ffd5 #00ffaa #00ff80 #00ff55 #00ff2b #00ff00 #2ad500 #55aa00 \
   #7f8000 #aa5500 #d42b00 #ff0000 #ff2a00 #ff5500 #ff7f00 #ffaa00 \
   #ffd400 #ffff00 #ffff2a #ffff55 #ffff7f #ffffaa #ffffd4 #ffffff \
]

set CM(hueWhite) [list \
   #ffffff #0000ff #002aff #0055ff #007fff #00aaff #00d4ff #00ffff \
   #00ffd5 #00ffaa #00ff80 #00ff55 #00ff2b #00ff00 #2ad500 #55aa00 \
   #7f8000 #aa5500 #d42b00 #ff0000 #ff2a00 #ff5500 #ff7f00 #ffaa00 \
   #ffd400 #ffff00 #ffff2a #ffff55 #ffff7f #ffffaa #ffffd4 #ffffff \
]

set CM(heat) [list \
   #000000 #170000 #2e0000 #450000 #5c0000 #730000 #8b0000 #a20000 \
   #b90000 #d00000 #ff0000 #ff1900 #ff3300 #ff4c00 #ff6600 #ff7f00 \
   #ff9900 #ffb200 #ffcc00 #ffe500 #ffff00 #ffff19 #ffff32 #ffff4b \
   #ffff64 #ffff7d #ffff96 #ffffb2 #ffffcc #ffffe5 #ffffff #ffffff \
]

set CM(topographic1) [list \
   #000000 #000033 #000066 #000099 #0000cc #0000ff #003fff #007fff \
   #00bfff #00ffff #00ffcc #00ff99 #00ff66 #00ff33 #00ff00 #10d000 \
   #20a000 #307000 #404000 #4c4c19 #595932 #66664c #737365 #80807f \
   #9f9f9f #bfbfbf #dfdfdf #ffffff #e0c0e0 #c080c0 #a040a0 #800080 \
]

set CM(topographic1White) [list \
   #ffffff #000033 #000066 #000099 #0000cc #0000ff #003fff #007fff \
   #00bfff #00ffff #00ffcc #00ff99 #00ff66 #00ff33 #00ff00 #10d000 \
   #20a000 #307000 #404000 #4c4c19 #595932 #66664c #737365 #80807f \
   #9f9f9f #bfbfbf #dfdfdf #ffffff #e0c0e0 #c080c0 #a040a0 #800080 \
]

set CM(hot&cold) [list \
   #000000 #00002a #000055 #00007f #0000aa #0000d4 #0000ff #0033ff \
   #0066ff #0099ff #00ccff #00ffff #19e6e6 #33cdcc #4cb3b3 #669a99 \
   #80807f #996766 #b24d4d #cc3433 #e51a1a #ff0000 #ff3300 #ff6600 \
   #ff9900 #ffcc00 #ffff00 #ffff33 #ffff66 #ffff99 #ffffcc #ffffff \
]
   
set palettemenu [list hue hueWhite topographic1 topographic1White topographic2 topographic2White heat hot&cold]
   
   
set preferences(CM.colours) $CM(hue)
set CM(defaults) $preferences(CM.colours)

set tkColorDialogLayout H

proc CM.make-frame {} {
   global env preferences CM MAXCOLOURS
   global palettemenu

   set CM(defaults) $preferences(CM.colours)

  :frame $CM(frame-name) :label "$CM(frame-title)" :show-footer T :toplevel T \
         :icon-image "@$env(ICONHOME)/spectrum"  \
           :icon-name $CM(icon-title) :resize F

  :panel CM-PANEL :layout T
    :layout H
 
    for {set i 0} {$i < $MAXCOLOURS} {incr i} {
       :canvas CM-SAMPLE$i :w 15 :h 60 :x [expr 15 * $i] :y 0
       :draw rectangle :tag S$i :colour [lindex $preferences(CM.colours) $i] :value 3 3 12 60
       [:path CM-SAMPLE$i] bind all <ButtonRelease-1> "CM-set-linecell $i"
       [:path CM-SAMPLE$i] bind all <ButtonRelease-3> "CM-take-linecell $i"
    }

   :panel CM-COLORSELECTION :padx 5 :pady 5 :layout T

   tkColorDialog [:path CM-COLORSELECTION]

  :panel CM-BUTTONS :layout B :padx 10
    :layout H; :col-gap 15
    :button CM-RESET        :label Reset               :command reset-colours
    :button CM-SAVE         :label "Save preferences"  :command update_preferences
    :menubutton CM-PALETTE  :label "Colour Palettes"   :strings $palettemenu :command CM.palette
    :button CM-STORE        :label "Palette Browser"   :command CM.browse
    :col-gap 25
    :button HELP 

  :show T
}

proc CM-set-linecell {b} {
   global preferences 
   global data               #  data interchange with tkColorDialog
   set CMcell $b
   set rgb $data(selection)
   [:path CM-SAMPLE$CMcell] itemconfigure S$b -fill $rgb
   set preferences(CM.colours) [lreplace $preferences(CM.colours) $CMcell $CMcell $rgb]
   inform sd set-colourmap [transparent $preferences(CM.colours)]
}

proc CM-take-linecell {b} {
   global preferences
   global w              #  data interchange with tkColorDialog
    set colour [lindex $preferences(CM.colours) $b]
    set rgb [winfo rgb . $colour]
    set r [expr [lindex $rgb 0]/0x100]
    set g [expr [lindex $rgb 1]/0x100]
    set b [expr [lindex $rgb 2]/0x100]
    tkColorDialog_SetRGBValue $w [list $r $g $b]
}

proc reset-colours {} {
   global preferences CM MAXCOLOURS
   set CMcell 0
   set preferences(CM.colours) $CM(defaults)
   for {set i 0} {$i<$MAXCOLOURS} {incr i 1} {
     [:path CM-SAMPLE$i] itemconfigure S$i -fill [lindex $preferences(CM.colours) $i]
   }
   inform sd set-colourmap [transparent $preferences(CM.colours)]
}   

proc CM.save {} {}
proc CM.repaint {} {}
proc CM.announce {} {}

proc initialise-colours {} {
   global preferences 
   send sd set-colourmap [transparent $preferences(CM.colours)]
}

proc CM.browse {} {
   inform cmdb start
}

proc CM.palette {w v i} {
   global CM
   CM.set-colours $CM($v)
}

proc CM.set-colours colours {
   global preferences CM MAXCOLOURS
   set lc [last $colours]
   for {set i [llength $colours]} {$i<$MAXCOLOURS} {incr i 1} {
      lappend colours $lc
   }
   set preferences(CM.colours) $colours
   for {set i 0} {$i<$MAXCOLOURS} {incr i 1} {
     [:path CM-SAMPLE$i] itemconfigure S$i -fill [lindex $preferences(CM.colours) $i]
   }
   inform sd set-colourmap [transparent $preferences(CM.colours)]
}

#    for converting palette from text format (in file $f) into internal list format
proc make_palette {f} {
    global palette

    set h [open $f r]
    set i [read $h]
    close $h
    
    set palette ""
    foreach item [split $i \n] {
        if {$item == ""} then {continue}
        set r [first $item]
        set g [second $item]
        set b [third $item]
        append palette [format "#%02x%02x%02x " $r $g $b]
    }
    return $palette
}
